const std = @import("std");
//const sdl = @import("sdl2");
//const zlm = @import("zlm");
//const gl = @import("zgl");
//const m = zlm.SpecializeOn(f32);
const rl = @import("raylib.zig");

const Self = @This();

color: [4]f32 = .{ 0, 0, 0, 0 },

// There's a vbo for each shader program
vbo: [max_objects]f32 = .{0.0} ** max_objects,
vbo_index: usize = 0,

// The index of the program is the enum converted to int
//textures: [max_objects]Texture = .{undefined} ** max_objects,

const max_objects: usize = 16384;
const quadSize: usize = 9 * 6;

pub fn init() !Self {
    rl.initWindow(640, 480, "USG", 60);

    var renderer = Self{};

    return renderer;
}

pub fn render(self: *Self) void {
    _ = self;

    rl.endDrawing();
    rl.beginDrawing();

    rl.clearBackground(232, 216, 166, 255);
}

pub fn deinit(self: *Self) void {
    _ = self;
}

//pub const OutputSize = struct { width: c_int, height: c_int };
//pub fn getOutputSize(self: Self) OutputSize {
//    var wsize = self.window.getSize();
//    return OutputSize{
//        .width = wsize.width,
//        .height = wsize.height,
//    };
//}

//pub const Texture = struct {
//    texture: gl.Texture,
//    width: usize,
//    height: usize,
//
//    pub fn init(data: [*]const u8, width: usize, height: usize) Texture {
//        var tex = gl.genTexture();
//        //defer gl.Texture.delete(tex);
//        gl.bindTexture(tex, .@"2d");
//
//        gl.textureImage2D(.@"2d", 0, .rgba, width, height, .rgba, .unsigned_byte, data);
//
//        gl.texParameter(.@"2d", .wrap_s, .clamp_to_edge);
//        gl.texParameter(.@"2d", .wrap_r, .clamp_to_edge);
//        gl.texParameter(.@"2d", .min_filter, .linear);
//        gl.texParameter(.@"2d", .mag_filter, .linear);
//
//        return Texture{
//            .texture = tex,
//            .width = width,
//            .height = height,
//        };
//    }
//
//    pub fn fromText(text: [:0]const u8, size: c_int) Texture {
//        var font = sdl.ttf.openFont("res/fonts/MarginaliaRegular-8XlZ.ttf", size) catch unreachable;
//        defer font.close();
//
//        var surface = font.renderTextBlended(text, sdl.Color.white) catch unreachable;
//        defer surface.destroy();
//
//        const width = @intCast(usize, surface.ptr.w);
//        const height = @intCast(usize, surface.ptr.h);
//        var newsurf = sdl.c.SDL_ConvertSurfaceFormat(surface.ptr, @enumToInt(sdl.PixelFormatEnum.argb8888), 0) orelse unreachable;
//        const data = @ptrCast([*]const u8, newsurf.pixels);
//
//        return Texture.init(data, width, height);
//    }
//
//    pub fn deinit(self: *Texture) void {
//        gl.Texture.delete(self.texture);
//    }
//};
